VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6135
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   6135
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox Text2 
      Height          =   390
      Left            =   2250
      TabIndex        =   4
      Text            =   "Text3"
      Top             =   225
      Width           =   1290
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Index           =   1
      Left            =   4125
      TabIndex        =   3
      Top             =   600
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Index           =   0
      Left            =   4050
      TabIndex        =   2
      Top             =   75
      Width           =   1695
   End
   Begin VB.TextBox Text3 
      Height          =   1935
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "Form1.frx":0000
      Top             =   720
      Width           =   2775
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   240
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' (softKUS) - X/2003
'---------------------------------------------------------------------------------------
'
' In diesem Beispiel wird gezeigt, wie der CPU-Takzhler (erst ab
' dem Pentium verfgbar!) genutzt werden kann, um sehr kleine
' Zeitspannen zu messen. Bei der Initialisierung wird sozusagen
' als Nebeneffekt die Taktfrequenz des Rechners ermittelt, was ins-
' besondere fr Programme ntzlich ist, deren Code auf allen Rechnern
' gleich schnell laufen soll.
'
' Das Beispiel besteht aus zwei Modulen:
' 1. Form1    - Dient blo der Demonstration
' 2. Module1  - Enthlt die eigentlichen CPU-Clock-Funktionen
'
' Die ASM-Quellcodes sind in den .ASM-Dateien enthalten.
'
'---------------------------------------------------------------------------------------
'
' Ein Formular mit:
' Text1, Text2, Text3 (multilined), Command1(0 bis 1)
'
'---------------------------------------------------------------------------------------

Option Explicit
Option Base 0

Private Const XYcm      As Long = 567       ' grerer Wert => grere Form
Private Const Ftxt      As String = "asm-Beispiel CPU-Taktzhler"

Private Sub Form_Load()
    Text1 = "0.0001"
    Text1.ToolTipText = "Wartezeit"
    
    Text2 = "10"
    Text2.ToolTipText = "Interval in ms (Schaltflche clkDelay)"
    
    Text3 = clkFMT(-clkINI(1)) & vbCrLf
    
    Command1(0).Caption = "Warten (clkWAIT)"
    Command1(0).ToolTipText = "Warten ohne DoEvents"
    Command1(1).Caption = "Warten (clkDELAY)"
    Command1(1).ToolTipText = "Warten mit DoEvents"
End Sub

Private Sub Form_Resize()
    Dim dfw As Long
    Dim dfh As Long
    Dim tmp As Long
    
    dfw = Me.Width - Me.ScaleWidth
    dfh = Me.Height - Me.ScaleHeight
    tmp = (Me.Controls.Count * 2.25 + 0.25) * XYcm + dfw
    
    If Me.Width < tmp Then Me.Width = tmp
    If Me.Height < 4 * XYcm Then Me.Height = 4 * XYcm
    
    With Text1:     .Top = 0.25 * XYcm      ' Zeitspanne
                    .Left = 0.25 * XYcm
                    .Width = 2 * XYcm
                    .Height = 0.5 * XYcm
    End With
    
    With Text2:     .Top = 0.25 * XYcm      ' Intervall
                    .Left = 2.5 * XYcm
                    .Width = 2 * XYcm
                    .Height = 0.5 * XYcm
    End With
    
    With Command1(1)
                    .Top = 0.25 * XYcm
                    .Left = Width - 3.25 * XYcm - dfw
                    .Width = 3 * XYcm
                    .Height = 0.5 * XYcm
    End With
    
    With Command1(0)
                    .Top = 0.25 * XYcm
                    .Left = Command1(1).Left - 3.25 * XYcm
                    .Width = 3 * XYcm
                    .Height = 0.5 * XYcm
    End With
    
    With Text3:     .Top = 1 * XYcm
                    .Left = 0.25 * XYcm
                    .Width = Me.Width - 0.5 * XYcm - dfw
                    .Height = Me.Height - 1.25 * XYcm - dfh
    End With
End Sub

Private Sub Command1_Click(Index As Integer)
    Dim txt      As String
    Dim lpcDelay As Currency
    Dim lpcWait  As Currency
    Dim dbl      As Double
    
    On Error Resume Next
    
    dbl = Val(Replace(Text1, ",", "."))
    
    If dbl = 0 Then
        Beep
    
    Else
        If Index = 0 Then
            dbl = clkWAIT(dbl, lpcWait)
        
        Else
            dbl = clkDELAY(dbl, Val(Text2), lpcDelay, lpcWait)
            txt = "Loopcount delay:  " & lpcDelay & vbCrLf
        End If
        
        txt = txt & "Loopcount wait:   " & lpcWait * 10000
        If Index = 1 Then txt = txt & " (" & clkFMT(lpcWait / clk_sec) & ")"
        txt = txt & vbCrLf & "Exakte Wartezeit: " & Format(dbl, "0.0000000000")
        Text3 = Text3 & txt & vbCrLf & vbCrLf
        Text3.SelStart = Len(Text3)
    End If
    
    Text3.SetFocus
End Sub
